;===============================================================
;  MSX STAR SOLDIER
;
;	タイトル配置
;
;===============================================================
org 	#5a60

val_c543_in_rom_19f7	equ		#c543+40*1		; ハイスコア書き出し先、1行下へ

proc_5a60:
proc
		ld		hl,disp_flag
		set		0,(hl)			; タイトル表示フラグON

		xor		a
		ld		(#cc89),a
		ld		ix,_extract_title
		ld		iyl,bank_titile_dat
		ld		hl,pcgcolpn_title_lzsa
		ld		a,r
		rrca
		jp		c,call_bank_titile_dat
		ld		a,1
		ld		(#cc89),a
		ld		hl,pcgcolpn_title_nes_lzsa
		jp		call_bank_titile_dat

	_extract_title:
		call	DecompressLZSA_to_d600

		; pcg書き込み
		ld		de,#400
	_lp_pgt:
		ld		hl,#d600
		ld		bc,#400
		call	blt_to_vram
		ld		a,d
		add		a,#20
		ld		d,a
		ld		bc,#400
		call	blt_to_vram
		ld		a,d
		sub		#20-8
		ld		d,a
		cp		#1c
		jr		nz,_lp_pgt

		push	hl
		ld		hl,#c288
		ld		de,#c289
		ld		bc,40*24
		ld		(hl),0
		ldir
		pop		hl

		; 配置パラメータ
		ld		e,(hl)
		inc		l
		ld		d,(hl)
		inc		l
		ld		c,(hl)
		inc		l
		ld		b,(hl)
		inc		l

	_lp_pnt:
		push	bc
		ld		b,0
		ldir
		pop		bc
		ld		a,40
		sub		c
		add		a,e
		ld		e,a
		jr		nc,_nx
		inc		d
	_nx:
		dec		b
		jr		nz,_lp_pnt

		; 文字列
		ld		hl,_txt
		ld		a,(hl)	; 件数
		inc		hl
		ld		b,0
	_lp_txt:
		ld		e,(hl)	; adr
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		c,(hl)	; len
		inc		hl
		ldir
		dec		a
		jr		nz,_lp_txt

		ret

	_txt:
		db	3	;件のデータ
		dw	#c288+5+ 40*#12 +#0a
		db	3,"TOP"
		dw	#c288+5+ 40*#12 +#14
		db	2,"00"
		dw	#c288+5+ 40*#14 +#07
		db	18,#b6,0,"1986",0,"HUDSON",0,"SOFT"
endp
