;===============================================================
;  MSX STAR SOLDIER
;
;	パレットアニメ
;
;===============================================================
hook_5c6f:
val_4390_in_rom_01c70	equ	hook_5c6f
		call	palette_anime_proc
		jp		#4390


palette_anime_proc:
proc
		ld		hl,palette_anime_tbl
	_lp:
		ld		a,(hl)	; パレット番号、#ffはアニメ無効
		or		a
		ret		m
		inc		l;hl
		dec		(hl)	; フレームカウンタ
		jr		nz,_next_tbl

		ld		b,a

		inc		l;hl
		ld		e,(hl)
		inc		l;hl
		ld		d,(hl)
		inc		l;hl
		ex		de,hl

		ld		a,(#0007)
		ld		c,a
		inc		c
		ld		a,#80+16
		di
		out		(c),b
		out		(c),a
		inc		c
		outi
		outi
		ei

		ld		a,(hl)
		cp		#ff
		jr		nz,_set_next_frame_data
		inc		hl
		ld		c,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,c
	_set_next_frame_data:
		ex		de,hl
		ld		a,(hl)
		dec		l;hl
		ld		(hl),d
		dec		l;hl
		ld		(hl),e
		dec		l;hl
		ld		(hl),a

	_next_tbl:
		;ld		bc,4
		;add		hl,bc
		inc		l
		inc		l
		inc		l
		inc		l
		jr		_lp
endp


palette_anime_set_nop:
		ld		a,#ff
		ld		(palette_anime_tbl),a
		call	update_palette
		ret
