;===============================================================
;  MSX STAR SOLDIER
;
;	特殊セルPCG
;
;===============================================================
load_spcell_pcg:
		ld		h,0
		rra
		rra
		rra
		rl		h
		ld		l,a
		ld		bc,pcg_spcell
		add		hl,bc

		ld		d,#84
		ld		ixh,3
		call	_lpH
		ld		de,#20
		add		hl,de
		ld		d,#e4
		ld		ixh,1
	_lpH:
		ld		e,#10
		call	set_vram_adr_de
		push	hl
		ld		ixl,4
		jr		_lp_in
	_lpL:
		push	hl

		ld		e,#10
		inc		c
		di
		out		(c),e
		out		(c),a
		ei
		dec		c
	_lp_in:
		ld		b,#10
		otir

		ld		e,#90
		inc		c
		di
		out		(c),e
		out		(c),a
		ei
		dec		c
		ld		b,#10
		otir

		pop		hl
		add		a,8
		dec		ixl
		jr		nz,_lpL

		ld		a,d
		add		a,#20
		ld		d,a
		dec		ixh
		jr		nz,_lpH
		ret

pcg_spcell:
		; くじら
		db	#80, #06, #09, #81, #03, #07, #f0, #13, #01, #c0, #20, #00, #84, #33, #13, #01
		db	#c4, #cc, #c0, #e0, #07, #80, #c0, #80, #01, #05, #0f, #e0, #0f, #00, #01, #01
		db	#0b, #0b, #0b, #8b, #0b, #0b, #b0, #0b, #0b, #0b, #0b, #bb, #0b, #b0, #b0, #b0
		db	#b0, #b0, #b0, #b0, #0b, #8b, #8b, #08, #b0, #b0, #b0, #0b, #b0, #bb, #8b, #08
		; 指
		db	#80, #07, #86, #09, #09, #09, #09, #38, #01, #01, #01, #01, #01, #c1, #8e, #a2
		db	#9c, #94, #90, #90, #30, #18, #f0, #00, #15, #05, #05, #05, #0d, #19, #0e, #00
		db	#1f, #01, #f1, #01, #01, #01, #01, #01, #0f, #01, #01, #01, #01, #01, #10, #f0
		db	#f1, #f1, #f1, #f1, #01, #01, #10, #00, #01, #01, #01, #01, #01, #01, #10, #00
		; ミロン
		db	#00, #07, #e0, #c0, #c4, #88, #80, #90, #00, #f0, #07, #01, #01, #03, #34, #74
		db	#4d, #61, #60, #00, #07, #07, #03, #00, #01, #01, #13, #f0, #e0, #20, #90, #00
		db	#00, #10, #01, #01, #01, #01, #01, #01, #00, #10, #01, #01, #01, #01, #b0, #b0
		db	#10, #b0, #b0, #00, #b0, #10, #10, #00, #0b, #0b, #0b, #b0, #b0, #10, #10, #00
		; レーザー
		db	#80, #80, #b8, #90, #90, #90, #92, #41, #10, #10, #10, #10, #10, #10, #10, #00
		db	#c0, #80, #81, #81, #81, #81, #81, #80, #10, #45, #41, #49, #49, #59, #79, #01
		db	#1f, #f1, #f1, #f1, #f1, #f1, #f1, #0f, #0f, #f1, #f1, #f1, #f1, #f1, #f1, #11
		db	#10, #f1, #f1, #f1, #f1, #f1, #f1, #10, #f1, #1f, #7f, #7f, #7f, #7f, #1f, #10
		; 野沢プログラマ
		db	#80, #07, #f0, #f0, #e0, #e4, #19, #18, #01, #3c, #0e, #0e, #06, #06, #06, #c6
		db	#e0, #e1, #e1, #18, #c4, #a6, #08, #80, #26, #26, #a6, #c6, #66, #ce, #c2, #00
		db	#cf, #0f, #f0, #f0, #f0, #f0, #0f, #0f, #cf, #f0, #c0, #c0, #c0, #c0, #c0, #c0
		db	#f0, #f0, #f0, #0f, #f0, #f0, #0c, #c0, #c0, #c0, #c0, #c0, #c0, #c0, #c0, #00
		; 裏パワー
		db	#00, #80, #80, #60, #50, #10, #30, #30, #00, #07, #03, #06, #39, #39, #06, #0e
		db	#30, #30, #30, #70, #60, #e0, #c0, #00, #01, #03, #80, #20, #60, #0f, #0f, #00
		db	#88, #8f, #8f, #f8, #f8, #f8, #f8, #f8, #88, #8f, #8f, #08, #80, #80, #08, #08
		db	#f8, #f8, #f8, #f8, #f8, #f0, #60, #66, #80, #80, #08, #08, #08, #80, #60, #66
		; 1up
		db	#e0, #c0, #70, #e0, #2a, #4a, #2a, #2a, #07, #03, #0e, #04, #70, #50, #50, #50
		db	#2a, #2a, #2a, #28, #e8, #e0, #c0, #e0, #70, #40, #40, #40, #41, #07, #03, #07
		db	#0f, #0f, #f8, #f8, #8f, #8f, #8f, #8f, #0f, #0f, #f8, #f8, #f8, #f8, #f8, #f8
		db	#8f, #8f, #8f, #8f, #f0, #68, #06, #06, #f8, #f8, #f8, #f8, #08, #68, #06, #06
		; ワープ
		db	#6a, #40, #c0, #a1, #cc, #4c, #cc, #4d, #a9, #03, #00, #0a, #93, #92, #93, #92
		db	#b0, #30, #46, #c2, #b2, #20, #80, #15, #12, #13, #32, #62, #c2, #03, #02, #a8
		db	#f6, #6f, #f8, #8f, #f8, #f8, #f8, #f8, #6f, #8f, #88, #6f, #6f, #6f, #6f, #6f
		db	#8f, #8f, #f8, #f8, #8f, #8f, #f6, #f6, #6f, #6f, #6f, #6f, #6f, #6f, #06, #f6

if 0
from array import array
from PIL import Image
def cnv(v,fm,to):
  fmh=fm&0xf0
  fml=fm&0x0f
  toh=to&0xf0
  tol=to&0x0f
  v=v if v&0xf0!=fmh else v&0x0f|toh
  v=v if v&0x0f!=fml else v&0xf0|tol
  return v

with open("ura-bg.pngsc2.bin","rb") as f:
  d=array("B",f.read())[7:]
  d=list(d[:0x800])+[cnv(cnv(i,0xee,0x33),0x44,0x11) for i in d[0x2000:0x2800]]

for i,n in enumerate(["くじら", "指", "ミロン", "レーザー", "野沢プログラマ", "裏パワー", "1up", "ワープ"]):
  print ";",n
  for j in [i*16,i*16+256,i*16+0x800,i*16+256+0x800]:
    print "db\t#"+", #".join(["%02x"%(k) for k in d[j:j+16]])
endif
