;===============================================================
;  MSX STAR SOLDIER
;
;	ボス、コアの移動の8dot化をやめる
;	スプライトアニメ追加
;
;===============================================================
org		#86e5
proc
		_idx	equ		#0b		;ボスのインデックスは固定値
		ld		b,0
		ld		de,0x18

		ld		hl,(#cf17)
		ld		a,(#c0c0+_idx)
		sub		l
		ld		l,a
		ld		(#c018+_idx),a
		ld		a,(#c120+_idx)
		sub		h
		ld		h,a
		ld		(#c030+_idx),a
		ld		(#ce74),hl
		jp		c,#8786			; x,yをf0にして終了

		; スプライトパターン更新
		ld		a,(#cf0d)
		or		a
		jr		z,_spr_end	; 大ボスはなし
		ld		a,(#cf28)
		or		a
		jr		nz,_spr_on	; 裏面はON
		ld		a,(#cde4)
		rrca
		jr		c,_spr_end	; 奇数ステージはなし
	_spr_on:
		ld		a,(#cf19)
		and		7
		ld		l,#28
		jr		nz,_set_ptn_no
		ld		l,#38
	_set_ptn_no:
		ld		a,l
		ld		(#c198+_idx),a
	_spr_end:

		ld		hl,#c030+_idx
		jp		#872b
endp
