;===============================================================
;  MSX STAR SOLDIER
;
;	特殊セル処理
;
;===============================================================


;===============================================================
;	アイテムクリア
;===============================================================
spcell_clear_item_stat:
		xor		a
		ld		(laser_stat),a
		ld		(item_stat),a
		ret
spcell_clear_item_stat2:
val_47f3_in_rom_0296	equ	spcell_clear_item_stat2
		xor		a
		ld		(item_stat),a
		ret


;===============================================================
;
;	特殊セルの自機ヒット処理
;
;===============================================================
hitchk_ship_x_spcell:
val_2a_in_rom_0c3e		equ	#cd
val_ce76_in_rom_0c3f	equ	hitchk_ship_x_spcell
proc
		ld		hl,(#ce76)	; map展開エリア参照
		ld		a,(hl)
		cp		#af
		jr		nz,_ck_df

		; extend
		ld		(hl),#26
		ld		hl,#cdf2
		inc		(hl)
		ld		a,(hl)
		jp		set_extend_se_and_call_43ee
	_ck_df:
		cp		#df
		ret		nz
		jp		spcell_warp_proc
endp



onshiphit_spcell_05:
val_32_in_rom_0c24		equ	#cd
val_cf20_in_rom_0c25	equ	onshiphit_spcell_05
		ld		(#cf20),a		; もともとの処理
		call	get_bg_adr_from_ce74
		ld		a,5
		jp		putchr16x16


;===============================================================
;
;	特殊セルのヒット時処理
;
;===============================================================
onhit_spcell_acdc:
		ld		hl,(#ce76)
		ld		a,(hl)
		and		#f
		cp		#f
		jp		z,#547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
		inc		(hl)
		cp		#e
		jp		nz,#547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
onhit_spcell_cmn:
		call	get_bg_adr_from_ce74
		ld		a,5
		call	putchr16x16
		jp		#547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret


onhit_spcell_e0:
proc
		ld		hl,(#ce76)
		inc		(hl)
		ld		a,(hl)
		cp		#e7
		jr		z, onhit_spcell_cmn
		cp		#ef
		jp		nz, #547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
		ld		(hl),#26

		ld		hl,item_stat
		bit		4,(hl)
		jr		nz,_end
		set		4,(hl)
		ld		a,#16
		call	#580e
		ld		a,#12
		call	#57a1
		ld		a,12
		ld		(#ce88),a
	_end:
		jp		#547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
endp


onhit_spcell_f0:
proc
		ld		hl,(#ce76)
		inc		(hl)
		jp		nz, #547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
		ld		(hl),#26

		ld		a,(#ce74)	; x位置
		and		#3
		ld		hl,#ce63	; スコア

		jr		nz,_ck1
		bit		0,(hl)
		jp		nz, #547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
		jr		_bns
	_ck1:
		dec		a
		jr		nz,_ck2
		inc		a
		ld		(#ce83),a
		ld		a,11		; SE:11 アイテム/ワープ
		ld		(#ce88),a
		jr		onhit_spcell_cmn
	_ck2:
		dec		a
		jr		nz,_ck3
		bit		0,(hl)
		jp		z, #547e	; e番目の自弾を消し、SE:2反射音にし 次キャラへ e-- if(e==0):0x50ae else:ret
		jr		_bns
	_ck3:
		ld		a,#80|#20
		ld		(laser_stat),a
		ld		a,11		; SE:11 アイテム/ワープ
		ld		(#ce88),a
		jp		onhit_spcell_cmn

	_bns:
		ld		a,#26
		call	#580e
		ld		a,#34
		call	#57a1
		ld		a,12
		ld		(#ce88),a
		jp		onhit_spcell_cmn
endp

val_542a_in_rom_129f	equ	onhit_spcell_acdc
val_542a_in_rom_12ab	equ	onhit_spcell_acdc
val_542a_in_rom_12ad	equ	onhit_spcell_e0
val_542a_in_rom_12af	equ	onhit_spcell_e0
val_542a_in_rom_12b1	equ	onhit_spcell_f0
val_542a_in_rom_12b3	equ	onhit_spcell_f0



;===============================================================
;
; セル配置
;
;===============================================================
spcell_st01: db #b9, #e1, #c9, #b2, #ff
spcell_st02: db #1d, #b1, #46, #12, #ff
spcell_st03: db #13, #11, #39, #08, #9d, #ac, #ff
spcell_st04: db #64, #06, #75, #c4, #d6, #ae, #ff
spcell_st05: db #72, #08, #d6, #ef, #ff
spcell_st06: db #9d, #0f, #ff
spcell_st07: db #85, #02, #a0, #b2, #ff
spcell_st08: db #51, #10, #91, #10, #ff
spcell_st09: db #7c, #d1, #9a, #e5, #ff
spcell_st10: db #26, #06, #7c, #10, #ff
spcell_st11: db #04, #a0, #5c, #12, #ff
spcell_st12: db #b8, #f0, #ff
spcell_st13: db #3f, #10, #56, #c9, #ff
spcell_st14: db #63, #02, #7e, #10, #ff
spcell_st15: db #af, #a1, #ff
spcell_st16: db #91, #02, #b5, #82, #ff

spcell_st02m: db #21, #a2, #46, #12, #ff
spcell_st03m: db #13, #11, #39, #08, #a1, #ac, #ff
spcell_st04m: db #5f, #06, #6d, #c1, #d6, #ae, #ff
spcell_st05m: db #69, #08, #d6, #ef, #ff
spcell_st07m: db #85, #02, #a1, #b2, #ff
spcell_st09m: db #6c, #d1, #9a, #e5, #ff
spcell_st10m: db #26, #06, #6c, #10, #ff
spcell_st11m: db #04, #a5, #5c, #12, #ff
spcell_st14m: db #53, #02, #6e, #10, #ff
spcell_st16m: db #91, #02, #c1, #82, #ff



if	spcell_st01>>8 = spcell_st16m>>8
spcell_list:
		db	spcell_st01,  spcell_st02m, spcell_st03m, spcell_st04m
		db	spcell_st05m, spcell_st06,  spcell_st07m, spcell_st08
		db	spcell_st09m, spcell_st10m, spcell_st11m, spcell_st12
		db	spcell_st13,  spcell_st14m, spcell_st15,  spcell_st16m
spcell_list2:
		db	spcell_st01, spcell_st02, spcell_st03, spcell_st04
		db	spcell_st05, spcell_st06, spcell_st07, spcell_st08
		db	spcell_st09, spcell_st10, spcell_st11, spcell_st12
		db	spcell_st13, spcell_st14, spcell_st15, spcell_st16

proc_put_spcell:
proc
		ld		a,(#cf21)
		inc		a
		ret		z
		dec		a
		ld		c,a

		ld		a,(cfg_map_type)
		rlca
		rlca
		rlca
		rlca
		ld		l,a
		ld		a,(#cde4)
		add		a,l
		add		a,spcell_list-1
		ld		h,spcell_list>>8
		ld		l,a
		if	0xf0 < (spcell_list & 0xff)
			jr		nc,_end_get_adr
			inc		h
		_end_get_adr:
		endif
		ld		l,(hl)
		ld		h,spcell_st01>>8
endp
else
spcell_list:
		dw	spcell_st01,  spcell_st02m, spcell_st03m, spcell_st04m
		dw	spcell_st05m, spcell_st06,  spcell_st07m, spcell_st08
		dw	spcell_st09m, spcell_st10m, spcell_st11m, spcell_st12
		dw	spcell_st13,  spcell_st14m, spcell_st15,  spcell_st16m
spcell_list2:
		dw	spcell_st01, spcell_st02, spcell_st03, spcell_st04
		dw	spcell_st05, spcell_st06, spcell_st07, spcell_st08
		dw	spcell_st09, spcell_st10, spcell_st11, spcell_st12
		dw	spcell_st13, spcell_st14, spcell_st15, spcell_st16

proc_put_spcell:
proc
		ld		a,(#cf21)
		inc		a
		ret		z
		dec		a
		ld		c,a

		ld		a,(cfg_map_type)
		or		a
		ld		l,a
		jr		z,_m
		ld		l,#20
	_m:
		ld		a,(#cde4)
		add		a,a
		add		a,l
		add		a,spcell_list-2
		ld		h,spcell_list>>8
		ld		l,a
		if	0xf0 < (spcell_list & 0xff)
			jr		nc,_end_get_adr
			inc		h
		_end_get_adr:
		endif
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
endp
endif
proc
		ld		a,c
	_lp:
		cp		(hl)
		ret		c
		jr		z,_hit
		inc		hl
		inc		hl
		jr		_lp
	_hit:
		inc		hl
		ld		a,(hl)
		ld		c,a
	;x座標
		and		#1f
		add		a,#89
		ld		l,a
		ld		h,#cc
	;パーツnoセット
		ld		a,c
		rlca
		rlca
		rlca
		and		7
		ld		(hl),a
		;0番のときはx座標mod4で
		or		a
		jr		nz,_end_cell_no
		ld		a,c
		and		3
		add		a,(hl)
		or		a
	_end_cell_no:
		ld		ix,load_spcell_pcg
		ld		iyl,bank_pcg_spcell
		jp		call_bank_pcg_spcell
endp



;===============================================================
;
; ワープ演出
;
;===============================================================
spcell_warp_proc:
proc
		call	#5683		; オールクラッシュ

		ld		a,4			; フェード現在色
		ld		(#ce73),a
		inc		a			; [0xc1e1]=5	; 自機ワープモード
		ld		(#c1e1),a		;
		ld		a,11
		ld		(#ce95),a	; BGM=11:BRAIN ESCAPED
		ld		(#ce89),a	; SE=11
		ld		a,#32		; ワープ終了カウンタ=0x20
		ld		(#cf11),a		;
		ld		a,8
		call	#580e	; メッセージ表示 WARP NEXT STAGE	

	_lp_warp:
		call	#5c64		; 同期処理,PAUSE処理
		call	#436f		; ゲームコア周期処理の途中
		call	spcell_warp_fade
		ld		hl,#cf11	; ワープ終了カウンタ--が0になるまでループ
		dec		(hl)
		jr		nz,_lp_warp
		inc		(hl)
		ld		a,(#c1e1)
		cp		6
		jr		nz,_lp_warp

		; スタック放棄して次ステージ処理へ
		pop		hl
		pop		hl

		ld		hl,#cde4
		inc		(hl)
		inc		(hl)
		jp		#428c
endp
spcell_warp_fade:
proc
		ld		hl,#ce73	; 現在色
		ld		a,(hl)
		dec		a
		ret		m

		add		a,#442f		; ワープ色 00, 40, 50, 70
		ld		d,#442f>>8
		ld		e,a

		ld		a,(#cf19)
		bit		2,a
		ret		nz

		and		3
		add		a,a
		add		a,a
		add		a,a
		add		a,#e0
		cp		#f8
		jr		nz,_sk
		dec		(hl)
	_sk:
		ld		h,a
		ld		l,0

		ld		a,(de)
		ld		bc,#200
		call	#016b
		inc		h
		inc		h
		inc		h
		ld		a,(de)
		ld		bc,#500
		jp		#016b
endp
